diff --git a/src/include/commands/vacuum.h b/src/include/commands/vacuum.h
index 956d9cea36d..31d40692f83 100644
--- a/src/include/commands/vacuum.h
+++ b/src/include/commands/vacuum.h
@@ -67,6 +67,80 @@
 /* Abstract type for parallel vacuum state */
 typedef struct ParallelVacuumState ParallelVacuumState;
 
+/* forward references for parallel table vacuum callbacks */
+struct ParallelContext;
+struct ParallelWorkerContext;
+
+/*
+ * Callbacks for parallel table vacuum.
+ *
+ * These are the table-AM specific routines that vacuumparallel.c calls to set
+ * up and perform a parallel scan of a table to collect dead items. Rather than
+ * living in the table AM (TableAmRoutine), which would mean generic vacuum
+ * code calling back up through the table-AM boundary it was entered from, an
+ * access method registers a callback struct under a name and vacuumparallel.c
+ * looks it up. The leader passes the struct directly to parallel_vacuum_init();
+ * workers only receive the name via shared memory and resolve it locally to a
+ * process-valid pointer (see parallel_vacuum_main()).
+ *
+ * compute_workers is optional; returning 0 (or leaving it NULL) disables
+ * parallel table vacuum, in which case the other callbacks are never called.
+ * If compute_workers returns a positive worker count, the remaining callbacks
+ * must all be provided.
+ */
+typedef struct ParallelVacuumCallbacks
+{
+	/*
+	 * Compute the number of parallel workers for parallel table vacuum. The
+	 * parallel degree for parallel vacuum is further limited by
+	 * max_parallel_maintenance_workers. The function must return 0 to disable
+	 * parallel table vacuum.
+	 *
+	 * 'nworkers_requested' is a >=0 number and the requested number of
+	 * workers. This comes from the PARALLEL option. 0 means to choose the
+	 * parallel degree based on the table AM specific factors such as table
+	 * size.
+	 */
+	int			(*compute_workers) (Relation rel,
+									int nworkers_requested,
+									void *state);
+
+	/*
+	 * Estimate the size of shared memory needed for a parallel table vacuum
+	 * of this relation.
+	 */
+	void		(*estimate) (Relation rel,
+							 struct ParallelContext *pcxt,
+							 int nworkers,
+							 void *state);
+
+	/*
+	 * Initialize DSM space for parallel table vacuum.
+	 */
+	void		(*initialize) (Relation rel,
+							   struct ParallelContext *pcxt,
+							   int nworkers,
+							   void *state);
+
+	/*
+	 * Initialize AM-specific vacuum state for worker processes.
+	 *
+	 * The state_out is the output parameter so that arbitrary data can be
+	 * passed to the subsequent callback, collect_dead_items.
+	 */
+	void		(*initialize_worker) (Relation rel,
+									  struct ParallelVacuumState *pvs,
+									  struct ParallelWorkerContext *pwcxt,
+									  void **state_out);
+
+	/*
+	 * Execute a parallel scan to collect dead items.
+	 */
+	void		(*collect_dead_items) (Relation rel,
+									   struct ParallelVacuumState *pvs,
+									   void *state);
+} ParallelVacuumCallbacks;
+
 /*----------
  * ANALYZE builds one of these structs for each attribute (column) that is
  * to be analyzed.  The struct and subsidiary data are in anl_context,
@@ -408,8 +482,14 @@ extern void VacuumUpdateCosts(void);
 extern ParallelVacuumState *parallel_vacuum_init(Relation rel, Relation *indrels,
 												 int nindexes, int nrequested_workers,
 												 int vac_work_mem, int elevel,
-												 BufferAccessStrategy bstrategy);
+												 BufferAccessStrategy bstrategy,
+												 const ParallelVacuumCallbacks *cbs,
+												 const char *am_name,
+												 void *state);
 extern void parallel_vacuum_end(ParallelVacuumState *pvs, IndexBulkDeleteResult **istats);
+extern int	parallel_vacuum_get_nworkers_table(ParallelVacuumState *pvs);
+extern Relation *parallel_vacuum_get_table_indexes(ParallelVacuumState *pvs, int *nindexes);
+extern BufferAccessStrategy parallel_vacuum_get_bstrategy(ParallelVacuumState *pvs);
 extern TidStore *parallel_vacuum_get_dead_items(ParallelVacuumState *pvs,
 												VacDeadItemsInfo **dead_items_info_p);
 extern void parallel_vacuum_reset_dead_items(ParallelVacuumState *pvs);
@@ -424,6 +504,8 @@ extern void parallel_vacuum_cleanup_all_indexes(ParallelVacuumState *pvs,
 												PVWorkerStats *wstats);
 extern void parallel_vacuum_update_shared_delay_params(void);
 extern void parallel_vacuum_propagate_shared_delay_params(void);
+extern int	parallel_vacuum_collect_dead_items_begin(ParallelVacuumState *pvs);
+extern void parallel_vacuum_collect_dead_items_end(ParallelVacuumState *pvs);
 extern void parallel_vacuum_main(dsm_segment *seg, shm_toc *toc);
 
 /* in commands/analyze.c */
diff --git a/src/test/modules/injection_points/Makefile b/src/test/modules/injection_points/Makefile
index c01d2fb095c..3aca8c389de 100644
--- a/src/test/modules/injection_points/Makefile
+++ b/src/test/modules/injection_points/Makefile
@@ -24,6 +24,8 @@ ISOLATION = basic \
 # some isolation tests require wal_level=replica
 ISOLATION_OPTS = --temp-config $(top_srcdir)/src/test/modules/injection_points/extra.conf
 
+TAP_TESTS = 1
+
 # The injection points are cluster-wide, so disable installcheck
 NO_INSTALLCHECK = 1
 
diff --git a/src/test/modules/injection_points/meson.build b/src/test/modules/injection_points/meson.build
index 59dba1cb023..9a33cb4a4b0 100644
--- a/src/test/modules/injection_points/meson.build
+++ b/src/test/modules/injection_points/meson.build
@@ -60,4 +60,9 @@ tests += {
       '--temp-config', files('extra.conf'),
     ],
   },
+  'tap': {
+    'tests': [
+      't/parallel_heap_vacuum.pl',
+    ],
+  },
 }
diff --git a/src/test/modules/injection_points/t/parallel_heap_vacuum.pl b/src/test/modules/injection_points/t/parallel_heap_vacuum.pl
new file mode 100644
index 00000000000..54bdc4b74c7
--- /dev/null
+++ b/src/test/modules/injection_points/t/parallel_heap_vacuum.pl
@@ -0,0 +1,138 @@
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+# Tests for parallel heap vacuum. It checks that the vacuum freezes correctly
+# across multiple scan rounds (with injection points forcing worker ramp-down
+# and leader resume), and that it plans the expected number of workers for
+# different PARALLEL requests and table sizes.
+
+use strict;
+use warnings FATAL => 'all';
+use locale;
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+# This test requires injection points; skip it when the build lacks them.
+if ($ENV{enable_injection_points} ne 'yes')
+{
+	plan skip_all => 'Injection points not supported by this build';
+}
+
+my $node = PostgreSQL::Test::Cluster->new('main');
+$node->init;
+$node->start;
+$node->safe_psql('postgres', qq[create extension injection_points;]);
+
+$node->safe_psql('postgres', qq[
+create table t (i int) with (autovacuum_enabled = off);
+create index on t (i);
+		 ]);
+my $nrows = 1_000_000;
+my $first = int($nrows * rand());
+
+my $psql = $node->background_psql('postgres', on_error_stop => 0);
+
+# Hold a transaction open to keep its xmin from advancing.
+$psql->query_safe('begin; select pg_current_xact_id();');
+
+# Advance the XID a few times, each in its own transaction.
+$node->safe_psql('postgres', 'select pg_current_xact_id()') for 1 .. 5;
+
+# Insert most rows under an old XID.
+$psql->query_safe(qq[insert into t select generate_series(1, $first);]);
+
+# Insert a few rows in a newer transaction, enough to fill at least one
+# page so it is not frozen by the vacuum below.
+my $xid = $node->safe_psql('postgres', qq[
+begin;
+insert into t select 0 from generate_series(1, 300);
+select pg_current_xact_id()::xid;
+commit;
+]);
+
+# Insert the remaining rows and commit the open transaction.
+$psql->query_safe(qq[insert into t select generate_series($first, $nrows);]);
+$psql->query_safe(qq[commit;]);
+
+# Delete a range of rows so the vacuum has dead items to collect.
+$node->safe_psql('postgres', qq[delete from t where i between 1 and 20000;]);
+
+# Run a parallel vacuum in multiple rounds. The low maintenance_work_mem
+# fills the dead-item store repeatedly, and the injection points ramp the
+# worker count down and disable leader participation. Everything except the
+# newer transaction's rows should freeze, advancing relfrozenxid to its XID.
+$node->safe_psql('postgres', qq[
+set vacuum_freeze_min_age to 5;
+set max_parallel_maintenance_workers TO 5;
+set maintenance_work_mem TO 256;
+select injection_points_set_local();
+select injection_points_attach('parallel-vacuum-ramp-down-workers', 'notice');
+select injection_points_attach('parallel-heap-vacuum-disable-leader-participation', 'notice');
+vacuum (parallel 5, verbose) t;
+		 ]);
+
+is( $node->safe_psql('postgres', qq[select relfrozenxid from pg_class where relname = 't';]),
+    "$xid", "relfrozenxid is updated as expected");
+
+# Check if we have successfully frozen the table in the previous
+# vacuum by scanning all tuples.
+$node->safe_psql('postgres', qq[vacuum (freeze, parallel 0, verbose, disable_page_skipping) t;]);
+is( $node->safe_psql('postgres', qq[select $xid < relfrozenxid::text::int from pg_class where relname = 't';]),
+    "t", "all rows are frozen");
+
+# Feature coverage for the number of parallel heap vacuum workers, that is, how
+# many workers are planned for different PARALLEL requests, table sizes, and the
+# max_parallel_maintenance_workers cap.  We assert on the "planned" count in the
+# VERBOSE output, which is deterministic, rather than the launched count, which
+# depends on background worker availability.
+
+# Return the "planned" heap-vacuum worker count from a VACUUM (VERBOSE) run, or
+# undef when no parallel-heap-vacuum message was emitted (i.e. serial).
+sub planned_table_workers
+{
+	my ($sql) = @_;
+	my ($ret, $stdout, $stderr) = $node->psql('postgres', $sql);
+	is($ret, 0, "vacuum ran: $sql");
+	if ($stderr =~ /for collecting dead tuples \(planned: (\d+)\)/)
+	{
+		return $1;
+	}
+	return undef;
+}
+
+# PARALLEL 0 disables parallel heap vacuum, so there is no message at all.
+is( planned_table_workers(
+		'set min_parallel_table_scan_size to "128kB"; vacuum (parallel 0, verbose) t;'
+	),
+	undef,
+	'PARALLEL 0 launches no parallel heap vacuum workers');
+
+# An explicit degree is honored (below the max_parallel_maintenance_workers cap).
+is( planned_table_workers(
+		'set min_parallel_table_scan_size to "128kB"; set max_parallel_maintenance_workers to 4; vacuum (parallel 2, verbose) t;'
+	),
+	2,
+	'PARALLEL 2 plans 2 parallel heap vacuum workers');
+
+# The request is capped by max_parallel_maintenance_workers.
+is( planned_table_workers(
+		'set min_parallel_table_scan_size to "128kB"; set max_parallel_maintenance_workers to 3; vacuum (parallel 8, verbose) t;'
+	),
+	3,
+	'PARALLEL request is capped by max_parallel_maintenance_workers');
+
+# A table below min_parallel_table_scan_size is vacuumed serially even when
+# parallelism is requested.
+$node->safe_psql('postgres', qq[
+	create table small (i int) with (autovacuum_enabled = off);
+	insert into small select generate_series(1, 100);
+]);
+is( planned_table_workers(
+		'set min_parallel_table_scan_size to "1GB"; vacuum (parallel 4, verbose) small;'
+	),
+	undef,
+	'small table is not vacuumed with parallel heap workers');
+
+$node->stop;
+done_testing();
diff --git a/src/test/regress/sql/vacuum_parallel.sql b/src/test/regress/sql/vacuum_parallel.sql
index 1d23f33e39c..5381023642f 100644
--- a/src/test/regress/sql/vacuum_parallel.sql
+++ b/src/test/regress/sql/vacuum_parallel.sql
@@ -1,5 +1,6 @@
 SET max_parallel_maintenance_workers TO 4;
 SET min_parallel_index_scan_size TO '128kB';
+SET min_parallel_table_scan_size TO '128kB';
 
 -- Bug #17245: Make sure that we don't totally fail to VACUUM individual indexes that
 -- happen to be below min_parallel_index_scan_size during parallel VACUUM:
@@ -39,8 +40,15 @@ VACUUM (PARALLEL 4, INDEX_CLEANUP ON) parallel_vacuum_table;
 -- assertion failure with bug #17245 (in the absence of bugfix):
 INSERT INTO parallel_vacuum_table SELECT i FROM generate_series(1, 10000) i;
 
+-- Insert more tuples to use parallel heap vacuum.
+INSERT INTO parallel_vacuum_table SELECT i FROM generate_series(1, 500_000) i;
+VACUUM (PARALLEL 2) parallel_vacuum_table;
+DELETE FROM parallel_vacuum_table WHERE a < 1000;
+VACUUM (PARALLEL 1) parallel_vacuum_table;
+
 RESET max_parallel_maintenance_workers;
 RESET min_parallel_index_scan_size;
+RESET min_parallel_table_scan_size;
 
 -- Deliberately don't drop table, to get further coverage from tools like
 -- pg_amcheck in some testing scenarios
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 223dfc80417..1ddc334e2e3 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -2063,6 +2063,11 @@ PLpgSQL_type
 PLpgSQL_type_type
 PLpgSQL_var
 PLpgSQL_variable
+ParallelLVLeader
+ParallelLVScanDesc
+ParallelLVScanWorkerData
+ParallelLVShared
+ParallelLVState
 PLwdatum
 PLword
 PLyArrayToOb
@@ -2137,6 +2142,7 @@ PVIndVacStatus
 PVOID
 PVShared
 PVSharedCostParams
+PVWorkPhase
 PVWorkerStats
 PVWorkerUsage
 PX_Alias
@@ -2175,6 +2181,7 @@ ParallelState
 ParallelTableScanDesc
 ParallelTableScanDescData
 ParallelTransState
+ParallelVacuumCallbacks
 ParallelVacuumState
 ParallelWorkerContext
 ParallelWorkerInfo
@@ -3358,6 +3365,7 @@ VacAttrStatsP
 VacDeadItemsInfo
 VacErrPhase
 VacOptValue
+VacuumCallbacksEntry
 VacuumCutoffs
 VacuumParams
 VacuumRelation
-- 
2.47.3

